#include <jni.h>
#include "cmodule.h"
#include <stdio.h>


/* Java_Test_Start_callCWithCallback
Diese Methode wird von Start.java gerufen, besorgt sich die methodid der java callback Methode und ruft 
diese auf.

*/
JNIEXPORT jint JNICALL Java_test_Start_callCWithCallback (JNIEnv * env, jobject obj){
 
  	jclass cls;
  	jmethodID mid;
  	printf( "Jetzt sind wir in callCWithCallbackC\n" );
	cls=env->GetObjectClass(obj);//jclass des rufenden Objekts besorgen
	mid=env->GetMethodID(cls, "callback", "()V"); //jmethodID der java methode callback besorgen
	env->CallVoidMethod(obj,mid); //methode callback im rufenden Objekt aufrufen
	return 0;
}

/*Java_test_Start_callCWithCallbackInOtherClass
Diese Methode wird von Start.java gerufen, erzeugt ein Objekt der Java-Klasse JavaFromC und ruft
die methode callback dieses Objekts.

*/

JNIEXPORT jint JNICALL Java_test_Start_callCWithCallbackInOtherClass (JNIEnv * env, jobject obj){
 	jclass cls;
  	jmethodID mid;
  	jobject jfcObj;
  	printf( "Jetzt sind wir in callCWithCallBackInOtherClassC\n" );
	cls = env->FindClass("test/JavaFromC"); //jclass von JavaFromC besorgen
	mid=env->GetMethodID(cls, "<init>", "()V"); //jmethodID des Konstruktors besorgen
	jfcObj = env->NewObject(cls, mid); //Objekt der Klasse JavaFromC erzeugen
	mid=env->GetMethodID(cls, "callback", "()V"); //jmethodID der java methode callback besorgen
	env->CallVoidMethod(jfcObj,mid);//methode callback im erzeugten Objekt aufrufen
	return 0;
}